#!/bin/csh -fe
if ( $#argv < 1) then
############################################################# 
echo "                                                         "
echo "     usage:  grd2rsc  file.grd "
echo "                                                         "
echo "             converts file.grd into i2 file and     "
echo "             writes an .rsc file                      "
echo ##########################################################
exit
else

set ifile=$1; set ofile=$ifile:r

set DIR=`pwd`
set par=`$GMT_BIN/grdinfo -C $ifile ` 
set x_min=$par[2]; set x_max=$par[3]; set y_min=$par[4]; set y_max=$par[5]; set z_min=$par[6]; set z_max=$par[7] 
set x_inc=$par[8]; set y_inc=$par[9]; set nx=$par[10];   set ny=$par[11] ; 

echo working.....
echo "grd2xyz $ifile -Zh >! $ofile.dem"
$GMT_BIN/grd2xyz $ifile -Zh >! $ofile.dem             # I am using int4 float (-Zf) didn't work with disfloat

# clean up WIDTH FILELENGTH XMAX and YMAX to be just integers (AVN)
#set nx=`echo $nx | awk -F"." '{print $1}'
#set ny=`echo $ny | awk -F"." '{print $1}'

cat >! $ofile.dem.rsc << EOF
FILE_DIR      $DIR
WIDTH         $nx
FILE_LENGTH   $ny
XMIN          0
XMAX          `echo "$nx-1" | bc`
YMIN          0
YMAX          `echo "$ny-1" | bc`
X_FIRST       $x_min
Y_FIRST       $y_max
X_STEP        $x_inc
Y_STEP        -$y_inc
X_UNIT        degrees
Y_UNIT        degrees
RLOOKS		  1
ALOOKS		  1
Z_OFFSET      0
Z_SCALE       1
PROJECTION    LATLON
DATE12        111111-222222
EOF

cat >! 111111_222222_baseline.rsc << EOF
P_BASELINE_TOP_ODR     000
EOF
