#!/usr/bin/perl

use Env qw(GMT_BIN);

foreach $fn ( @ARGV )
{ print "$fn\n";
  $fn =~ /(.)(..)(.)(...)/;

  $nsh = $1; $blat = $2; $ewh = $3; $llon = $4;

  if (lc($nsh) eq "s") { $blat *= -1.0; }
  if (lc($ewh) eq "w") { $llon *= -1.0; }

  $lon0 = $llon; $lon1 = $llon+1.0;
  $lat0 = $blat; $lat1 = $blat+1.0;

  $range = sprintf "%.0f/%.0f/%.0f/%.0f", $lon0, $lon1, $lat0, $lat1;

  $outfn = $fn;
  $outfn =~ s/hgt/grd/g; 

 
 if (-s $fn > 20000000) {

  system ("$GMT_BIN/xyz2grd $fn -G$outfn -I1c/1c -R$range -ZTLhw");
}
 
else{
system ("$GMT_BIN/xyz2grd $fn -G$outfn -I3c/3c -R$range -ZTLhw");
}

# system ("$GMT_BIN/grdmath $outfn -32768 NAN = $outfn");
}

###################################
## TO MERGE SEVERAL FILES##########
#grdmerge.pl -Gs32.grd S32*.grd

#grdmerge.pl -Gs33.grd S33*.grd 

#grdmerge.pl -Gall.grd s32.grd s33.grd


###################################
## TO MAKE A PS FILE ##############

#grd2cpt -Crainbow $file > ${file}.cpt -V

#grdgradient $file -A0/270 -G${file}_grad -Ne0.6 -V

#grdimage $file -JM16c -I${file}_grad -P -V -R-116.10100/-114.59900/31.30000/32.70190 -C$file.cpt > ${file}.ps


###############################################
## To make gtopo30 for merging with srtm data:#

#// Set a larger area
#set R=-R-117/-114/31.00000/33
#set file=gtopoB.grd
#grdraster 4 $R -I1m -G$file

#// Resample with good interval and good bounds
#grdsample $file -G${file}.samp -I0.00083 -R-116.10100/-114.59900/31.30000/32.7190 -V

############################################
## OUTPUT THE DEM TO roi_pac################

#grd2xyz baja.grd -ZTLh -V > baja.dem
