#!/usr/bin/perl

### Modifdem.pl

$] >= 5.004 or die "Perl version must be >= 5.004 (Currently $]).\n";

use Env qw(MAKEDEMHOME MAKEDEM_BIN MAKEDEM_SCR MATLAB_BIN GMT_BIN INT_SCR);
use lib "$INT_SCR";  #### Location of Generic.pm
use Getopt::Long;
use Generic;

GetOptions('h' => \$help, '--resample=s' => \$resample, '--resize=s' => \$resize, 'o=s' => \$ofile, '--deminfo' => \$deminfo, '--clean' => \$clean  ) ;

###Usage info/check
sub Usage{
print STDERR "lookdem.pl demfile.dem -o outfile --resample x_step/y_step --resize west/east/south/north \n";

$INT_SCR/mkdemroi.pl;
exit 1;
}

@ARGV >= 1  or Usage();


$infile=shift;


############
# Get info #
############

$X_FIRST = Use_rsc "${infile}.rsc read X_FIRST";
$Y_FIRST = Use_rsc "${infile}.rsc read Y_FIRST";
$WIDTH = Use_rsc "${infile}.rsc read WIDTH";
$FILE_LENGTH = Use_rsc "${infile}.rsc read FILE_LENGTH";
$X_STEP = Use_rsc "${infile}.rsc read X_STEP";
$Y_STEP = Use_rsc "${infile}.rsc read Y_STEP";
use POSIX;
$X_EAST = $X_FIRST+$X_STEP*($WIDTH-1);
$Y_SOUTH = $Y_FIRST+$Y_STEP*($FILE_LENGTH-1);
$gY_STEP = -$Y_STEP;

if ($ofile){}

else{
@ofile=split(/.dem/,$infile);
$ofile=@ofile[0];
}
chomp $ofile;

if ($deminfo) {

print STDERR "West/East/South/North: $X_FIRST/$X_EAST/$Y_SOUTH/$Y_FIRST\n";
print STDERR "X/Ystep:               $X_STEP/$Y_STEP\n";
print STDERR "Width/Length:          $WIDTH/$FILE_LENGTH\n";

}

if ($resample) {
print STDERR " ## RESAMPLE ## \n ";

`$GMT_BIN/xyz2grd $infile -G$infile.grd -I$X_STEP/$gY_STEP -R$X_FIRST/$X_EAST/$Y_SOUTH/$Y_FIRST -Zh`;

@factors=split(/,/,$resample);
print STDERR "@factors[0]/@factors[1] \n";
`$GMT_BIN/grdsample $infile.grd -G$ofile.grd -I@factors[0]/@factors[1]`;

#$resample`;

`$MAKEDEM_SCR/grd2rsc.csh $ofile.grd`;

if ($clean) {
`rm $infile.grd `;
}


$infile="$ofile.dem";

$X_FIRST = Use_rsc "${infile}.rsc read X_FIRST";
$Y_FIRST = Use_rsc "${infile}.rsc read Y_FIRST";
$WIDTH = Use_rsc "${infile}.rsc read WIDTH";
$FILE_LENGTH = Use_rsc "${infile}.rsc read FILE_LENGTH";
$X_STEP = Use_rsc "${infile}.rsc read X_STEP";
$Y_STEP = Use_rsc "${infile}.rsc read Y_STEP";
use POSIX;
$X_EAST = $X_FIRST+$X_STEP*($WIDTH-1);
$Y_SOUTH = $Y_FIRST+$Y_STEP*($FILE_LENGTH-1);
$gY_STEP = -$Y_STEP;

}

if ($resize) {
print STDERR "## RESIZE ## \n ";

`$GMT_BIN/xyz2grd $infile -G$infile.grd -I$X_STEP/$gY_STEP -R$X_FIRST/$X_EAST/$Y_SOUTH/$Y_FIRST -Zh`;

@limites=split(/\//,$resize);

$east=@limites[0]+(ceil((@limites[1]-@limites[0])/$X_STEP))*$X_STEP;
$south=@limites[3]+(ceil((@limites[3]-@limites[2])/$gY_STEP))*$Y_STEP;

print STDERR "Actual resize limites @limites[0] $east $south @limites[3] \n";

`$GMT_BIN/grdcut $infile.grd -G$ofile -R@limites[0]/$east/$south/@limites[3]`;
`$MAKEDEM_SCR/grd2rsc.csh $ofile`;

}

if ($clean) {
`rm $infile.grd $ofile`;
}

exit 0;

=pod 

=head1 USAGE

B<lookdem.pl> I<bbb>

date:           radical of the input file I<date>.raw

