#!/usr/bin/perl
### makedem.pl
Log ("makedem.pl", @ARGV);


$] >= 5.004 or die "Perl version must be >= 5.004 (Currently $]).\n";

use Env qw(MAKEDEMHOME MAKEDEM_BIN MAKEDEM_SCR MATLAB_BIN GMT_BIN INT_SCR);
use lib "$INT_SCR";  #### Location of Generic.pm
use Generic;
use Getopt::Long;

GetOptions('o=s' => \$ofile,'nodisplay' => \$nodisplay );

###Usage info/check
sub Usage{
print STDERR "makedem.pl -o outfile -- west east south north srtm1/3 [posting factor] \n";
print STDERR " eg:    makedem.pl -o Etna_srtm -- 14.7 15.3 37.5 37.92 srtm3  \n";
print STDERR "                      srtm1 for 1 arc second DEM (30 m)     \n";
print STDERR "                      srtm3 for 3 arc second DEM (90 m)     \n";
print STDERR "                      the posting factor changes the sampling:     \n";
print STDERR "                      srtm3 0.333 provides 30 m, srtm1 0.333 provides 10 m and srtm3 2 provides 180 m data :     \n";
exit 1;
}
@ARGV >= 5  or Usage();
Log("makedem.pl", @ARGV) ;

$xmini=shift;
$xmaxi=shift;
$ymini=shift;
$ymaxi=shift;
$DIR=shift;
$fact=shift or $fact=1;

$version="version2";

`$GMT_BIN/gmtset D_FORMAT %12.8f`;

#################
## Prepare dir ##
#################

$rpwd=`pwd`;
chomp($rpwd);

! -d "$rpwd/tmp" or `rm -r -f $rpwd/tmp`;

`mkdir $rpwd/tmp`;

chdir "$rpwd/tmp";


###############
#Reformat data#
###############

$xmin = sprintf("%03.1f", $xmini);
$xmax = sprintf("%03.1f", $xmaxi);
$ymin = sprintf("%03.1f", $ymini);
$ymax = sprintf("%03.1f", $ymaxi);


$xsgn=substr($xmin,0,-5);
$xval=substr($xmin,-5);

$Xsgn=substr($xmax,0,-5);
$Xval=substr($xmax,-5);

$ysgn=substr($ymin,0,-4);
$yval=substr($ymin,-4);

$Ysgn=substr($ymax,0,-4);
$Yval=substr($ymax,-4);


use POSIX;
#Round input

if ($xsgn ne "-"){
$xmindow = sprintf("%03d", floor($xval));
$xmindown = "${xsgn}${xmindow}";
}
else{
$xmindow = sprintf("%03d", ceil($xval));
$xmindown = "${xsgn}${xmindow}";
}

if ($ysgn ne "-"){
                  $ymindow= sprintf("%02d", floor($yval));
                  $ymindown = "${ysgn}${ymindow}";
}else{
                  $ymindow = sprintf("%02d", ceil($yval));
                  $ymindown = "${ysgn}${ymindow}";
}

chomp $ymindown;

if ($Xsgn ne "-"){
                   $xmaxdow = sprintf("%03d", ceil($Xval));
                   $xmaxdown = "${Xsgn}${xmaxdow}";
}else{
                   $xmaxdow = sprintf("%03d", floor($Xval));
                   $xmaxdown = "${Xsgn}${xmaxdow}";
}

if ($Ysgn ne "-"){
                   $ymaxdow = sprintf("%02d", ceil($Yval));
                   $ymaxdown = "${Ysgn}${ymaxdow}";
}else{
                   $ymaxdow = sprintf("%02d", floor($Yval));
                   $ymaxdown = "${Ysgn}${ymaxdow}";
}

#`rm *grd* *zip *gmt *grid*`;


Message "####################";
Message ">>>>Get files by ftp";
Message "####################";

for( my $i=$xmindown; $i<=${xmaxdown}-1; $i++ ){
 for( my $j=$ymindown; $j<=${ymaxdown}-1; $j++ ){

 $isgn=substr($i,0,1);
 $jsgn=substr($j,0,1);

 if ( $isgn eq "-" ){
                     $long=W;
                     $ii=substr($i,1);
                     $ii=sprintf("%03d", $ii);
 }else{
                     $long=E;
                     $ii=sprintf("%03d", $i);
 }


if ( $jsgn eq "-" ){
                     $lati=S;
                     $jj=substr($j,1);
                     $jj=sprintf("%02d", $jj);
 }else{
                     $lati=N;
                     $jj=sprintf("%02d", $j);
 }

 $FILE="${lati}${jj}${long}${ii}.hgt";
 chomp $FILE;
 Message "$FILE.zip";

sub precision{
  $FILE=shift;
  $version=shift;
  $DIR=shift;
  
  if (-e "$FILE"){
  }
  else{



    if ($version eq "version1"){
      if ($DIR eq "srtm1"){
        @directories=("srtm/version1/United_States_1arcsec/1arcsec");
      }
      else{ 
        @directories=("srtm/version1/Africa", "srtm/version1/Australia", "srtm/version1/North_America_3arcsec/3arcsec","srtm/version1/South_America","srtm/version1/Eurasia","srtm/version1/Islands");
      }
    }

    if ($version eq "version2"){

      if ($DIR eq "srtm1"){
        @directories=("srtm/version2/SRTM1/Region_01","srtm/version2/SRTM1/Region_02","srtm/version2/SRTM1/Region_03","srtm/version2/SRTM1/Region_04","srtm/version2/SRTM1/Region_05","srtm/version2/SRTM1/Region_06","srtm/version2/SRTM1/Region_07",);
      }
      else{
        @directories=("srtm/version2/SRTM3/Africa","srtm/version2/SRTM3/Australia","srtm/version2/SRTM3/North_America","srtm/version2/SRTM3/South_America","srtm/version2/SRTM3/Eurasia","srtm/version2/SRTM3/Islands");
      }
    }

    foreach $directories (@directories){
      Message "$directories";
      chomp $FILE;
      `$MAKEDEM_SCR/ftp_srtm.fast . $FILE.zip $directories`;
      if (-e "$FILE.zip"){
        Message " OK ";
        `unzip $FILE.zip`;
        `rm $FILE.zip`;
      }	 
    }
  }
}
precision($FILE,$version,$DIR);

 }
}


Message "#########################";
Message ">>>>Store increment value";
Message "#########################";

@hgtfiles=`ls *hgt`;

#$DIR $#hgtfiles >= 0 or die "STOP No hgt files \n";
if (($#hgtfiles == -1) && ($DIR eq "srtm1")){
  Message ("// ATTENTION //: No 30 meters DEM, trying with 90 meters and resampling");
  precision($FILE,$version,srtm3);
  $fact and $fact=$fact/3 or $fact=1/3;
  @hgtfiles=`ls *hgt`;
}
elsif ($#hgtfiles == -1){ die "STOP No hgt files \n"; }

Message "@hgtfiles";
`$MAKEDEM_SCR/hgt2grd.pl $hgtfiles[0]`;
Message "@hgtfiles";
@grdfiles=`ls *grd`;
$tete=$grdfiles[0];
chomp $tete;
`which $GMT_BIN/grdinfo`;
`$GMT_BIN/grdinfo  $tete > tmp1.gmt`;
$width=`grep 'nx' tmp1.gmt | awk '{print \$11 }'`;
chomp $width;
$Xmin=`grep 'nx' tmp1.gmt | awk '{print \$3 }'`;
chomp $Xmin;
$Xmax=`grep 'nx' tmp1.gmt | awk '{print \$5 }'`;
chomp $Xmax;
$incX=($Xmax-$Xmin)/($width-1);
$FactincX=$incX*$fact;
chomp ($FactincX);
$incX = sprintf("%03.12f", $incX);
chomp $incX;
Message "$tete";
#`$GMT_BIN/grdsample $tete -G"sample" -I$incX -Q`;
#`mv sample $tete`;

@grdfiles=`ls *grd`;
$tete=$grdfiles[0];
chomp $tete;
`$GMT_BIN/grdinfo  $tete > tmp1.gmt`;
$width=`grep 'nx' tmp1.gmt | awk '{print \$11 }'`;
chomp $width;

Message "#########################################";
Message ">>>>Transform files and create gtopofiles";
Message "#########################################";

for( my $i=$xmindown; $i<=${xmaxdown}-1; $i++ ){
 for( my $j=$ymindown; $j<=${ymaxdown}-1; $j++ ){

  $isgn=substr($i,0,1);
  $jsgn=substr($j,0,1);

  if ( $isgn eq "-" ){
   $long=W;
   $ii=substr($i,1);
   $ii=sprintf("%03d", $ii);
  }
  else{
   $long=E;
   $ii=sprintf("%03d", $i);
  }

  if ( $jsgn eq "-" ){
   $lati=S;
   $jj=substr($j,1);
   $jj=sprintf("%02d", $jj);
  }
  else{
   $lati=N;
   $jj=sprintf("%02d", $j);
  }

 $FILE="$lati${jj}${long}${ii}.hgt";
 $FILEgrd="$lati${jj}${long}${ii}.grd"; 
 Message "$FILEgrd";
 if (-e "$FILE"){ #Case of existing hgt file
  `$MAKEDEM_SCR/hgt2grd.pl $FILE`;
  `$GMT_BIN/grdsample $FILEgrd -Gsrtm$FILEgrd -I${incX} -Q`;
 }
 else{            #Case of no hgt file
      chomp $FILEgrd;
      chomp $grdfiles[0];
      Message "blank $FILEgrd";
      $ip=$i+1;
      $jp=$j+1;
      print STDERR " grdedit $grdfiles[0] srtm$FILEgrd -R$i/$ip/$j/$jp \n";
      `$GMT_BIN/grdmath $grdfiles[0] 0 MUL = srtm$FILEgrd`; 
      `$GMT_BIN/grdedit srtm$FILEgrd -R$i/$ip/$j/$jp`;

  }
  `$GMT_BIN/grdedit srtm$FILEgrd -A`;
  `$GMT_BIN/grdinfo srtm$FILEgrd > tmp.gmt`;
  $width=`grep 'nx' tmp.gmt | awk '{print \$11 }'`;
  chomp $width;
  $xMin =`grep 'nx' tmp.gmt | awk '{print \$3 }'`;
  chomp $xMin;
  $xMax =`grep 'nx' tmp.gmt | awk '{print \$5 }'`;
  chomp $xMax;
  $yMin =`grep 'ny' tmp.gmt | awk '{print \$3 }'`;
  chomp $yMin;
  $yMax =`grep 'ny' tmp.gmt | awk '{print \$5 }'`;
  chomp $yMax;
  $incx =($xMax-$xMin)/($width-1);
  chomp $incx;
  $incx = sprintf("%03.12f", $incx);
  chomp $incx;
# Message "$incx";
  `$GMT_BIN/grdraster 7 -R${xMin}/${xMax}/${yMin}/${yMax} -I1m -Ggtopo$FILEgrd`; #Get Gtopo30
  `$GMT_BIN/grdinfo gtopo$FILEgrd > tmpgtopo.gmt`;
  $Test=`grep 'registration' tmpgtopo.gmt | awk '{print  \$2 }'`;
  chomp $Test;
  if ($Test eq "Pixel"){
   `$GMT_BIN/grdsample gtopo$FILEgrd -Ggtopo$FILEgrd.T -T -Q -V`;
   `$GMT_BIN/grdsample gtopo$FILEgrd.T -Ggtopo$FILEgrd.T.samp -I$incx -R${xMin}/${xMax}/${yMin}/${yMax} -Q -V`;
  }
  else{
 `$GMT_BIN/grdsample gtopo$FILEgrd -Ggtopo$FILEgrd.T.samp -I$incx -R${xMin}/${xMax}/${yMin}/${yMax} -Q -V`;
  }
  `rm gtopo$FILEgrd`;
 
 }
}


Message "#####################";
Message ">>>>concatenate tiles";
Message "#####################";

for( my $j=$ymindown; $j<=${ymaxdown}-1; $j++ ){

$jsgn=substr($j,0,1);

 if ( $jsgn eq "-" ){
  $lati=S;
  $jj=substr($j,1);
  $jj=sprintf("%02d", $jj);
 }
 else{
  $lati=N;
  $jj=sprintf("%02d", $j);
 }
 Message "$jj";
 @files=split /\s+/, `ls srtm${lati}${jj}*grd`;
 Message "@files";
 if ($#files >= 1) { 
Message "$MAKEDEM_SCR/grdmerge.pl -GSRTM${jj}.out.grd srtm${lati}${jj}*grd";
Message "$MAKEDEM_SCR/grdmerge.pl -GGTOPO${jj}.out.grd gtopo${lati}${jj}*grd.T.samp";

  `$MAKEDEM_SCR/grdmerge.pl -GSRTM${jj}.out.grd srtm${lati}${jj}*grd`;
  `$MAKEDEM_SCR/grdmerge.pl -GGTOPO${jj}.out.grd gtopo${lati}${jj}*grd.T.samp`;
 }
 else{
  `cp srtm${lati}${jj}*grd SRTM${jj}.out.grd`;
  `cp gtopo${lati}${jj}*grd.T.samp GTOPO${jj}.out.grd`;
 }
}

@fiiles=split /\s+/, `ls SRTM*grd`;
 Message "@fiiles";
if ($#fiiles >= 1) { 

Message "grdmerge.pl -GSrtmAll.grd SRTM*out.grd";
Message "grdmerge.pl -GGtopoAll.grd GTOPO*out.grd";

 `$MAKEDEM_SCR/grdmerge.pl -GSrtmAll.grd SRTM*out.grd`; 
 `$MAKEDEM_SCR/grdmerge.pl -GGtopoAll.grd GTOPO*out.grd`; 

}
else{
  `cp SRTM*grd SrtmAll.grd`;
  `cp GTOPO*grd GtopoAll.grd`;
 }


  $width=sprintf("%08d",floor(($xmaxi-$xmini)/$incx+1));
  chomp $width;
  $lenght=sprintf("%08d",floor(($ymaxi-$ymini)/$incx+1));
  chomp $lenght;
  $xMaxi =$xmini+$incx*($width-1);
  chomp $xMaxi;
  $yMaxi =$ymini+$incx*($lenght-1);
  chomp $yMaxi;
 
Message "grdcut SrtmAll.grd -GSrtmAllcmsk.grd -R${xmini}/${xMaxi}/${ymini}/${yMaxi}";
Message "grdcut GtopoAll.grd -GGtopoAllc.grd -R${xmini}/${xMaxi}/${ymini}/${yMaxi}`"; 


`$GMT_BIN/grdcut SrtmAll.grd -GSrtmAllcmsk.grd -R${xmini}/${xMaxi}/${ymini}/${yMaxi}`;
`$GMT_BIN/grdcut GtopoAll.grd -GGtopoAllc.grd -R${xmini}/${xMaxi}/${ymini}/${yMaxi}`;

`$GMT_BIN/grdedit SrtmAllcmsk.grd -A `;
`$GMT_BIN/grdedit GtopoAllc.grd -A `;

`$GMT_BIN/grdinfo SrtmAllcmsk.grd > tmpAll.gmt`;

Message "###################################";
Message ">>>>Mask with coastline";
Message "###################################";

Message "grdlandmask -GMask.grd -I$incx -R${xmini}/${xMaxi}/${ymini}/${yMaxi} -N0/1/1/1/1 -Df";

`$GMT_BIN/grdlandmask -GMask.grd -I$incx -R${xmini}/${xMaxi}/${ymini}/${yMaxi} -N0/1/1/1/1 -Df`;


Message "###################################";
Message ">>>>File holes in SRTM with Gtopo30";
Message "###################################";

$xMaxi=$xMaxi-$incx;
chomp $xMaxi;
$xmini=$xmini+$incx;
chomp $xmini;
$intermWidth = sprintf("%03d", floor(($width-3)/2));
chomp $intermWidth;
$xinterm =$xmini+$incx*($intermWidth);
chomp $xinterm;

Message "grdcut SrtmAllcmsk.grd -GSrtmAllcmsk1.grd -R${xmini}/${xinterm}/${ymini}/${yMaxi} -V";
Message "grdcut SrtmAllcmsk.grd -GSrtmAllcmsk2.grd -R${xinterm}/${xMaxi}/${ymini}/${yMaxi} -V";
Message "grdcut GtopoAllc.grd -GGtopoAllc1.grd -R${xmini}/${xinterm}/${ymini}/${yMaxi} -V";
Message "grdcut GtopoAllc.grd -GGtopoAllc2.grd -R${xinterm}/${xMaxi}/${ymini}/${yMaxi} -V";
Message "grdcut Mask.grd -GMask1.grd -R${xmini}/${xinterm}/${ymini}/${yMaxi} -V";
Message "grdcut Mask.grd -GMask2.grd -R${xinterm}/${xMaxi}/${ymini}/${yMaxi} -V";

`$GMT_BIN/grdcut SrtmAllcmsk.grd -GSrtmAllcmsk1.grd -R${xmini}/${xinterm}/${ymini}/${yMaxi} -V`;
`$GMT_BIN/grdcut SrtmAllcmsk.grd -GSrtmAllcmsk2.grd -R${xinterm}/${xMaxi}/${ymini}/${yMaxi} -V`;
`$GMT_BIN/grdcut GtopoAllc.grd -GGtopoAllc1.grd -R${xmini}/${xinterm}/${ymini}/${yMaxi} -V`;
`$GMT_BIN/grdcut GtopoAllc.grd -GGtopoAllc2.grd -R${xinterm}/${xMaxi}/${ymini}/${yMaxi} -V`;
`$GMT_BIN/grdcut Mask.grd -GMask1.grd -R${xmini}/${xinterm}/${ymini}/${yMaxi} -V`;
`$GMT_BIN/grdcut Mask.grd -GMask2.grd -R${xinterm}/${xMaxi}/${ymini}/${yMaxi} -V`;

`$MAKEDEM_SCR/grd2rsc.csh SrtmAllcmsk1.grd`;
`$MAKEDEM_SCR/grd2rsc.csh SrtmAllcmsk2.grd`;
`$MAKEDEM_SCR/grd2rsc.csh GtopoAllc1.grd`;
`$MAKEDEM_SCR/grd2rsc.csh GtopoAllc2.grd`;
`$MAKEDEM_SCR/grd2rsc.csh Mask1.grd`;
`$MAKEDEM_SCR/grd2rsc.csh Mask2.grd`;


  `$MATLAB_BIN/matlab -nojvm -nosplash -nodesktop <<EOF
         addpath(strcat(getenv('MAKEDEMHOME'),'/', 'mfiles' ));
         figure; close
         messy_srtm2ok ('SrtmAllcmsk1.dem','GtopoAllc1.dem','Mask1.dem','DEM1ok')
         EOF`;

  `$MATLAB_BIN/matlab -nojvm -nosplash -nodesktop <<EOF
          addpath(strcat(getenv('MAKEDEMHOME'),'/', 'mfiles' ));
          figure; close
          messy_srtm2ok ('SrtmAllcmsk2.dem','GtopoAllc2.dem','Mask2.dem','DEM2ok')
   EOF`;

`rm -f *dem*`;

Message "xyz2grd DEM1ok -GDEM1ok.grd -I$incx -R${xmini}/${xinterm}/${ymini}/${yMaxi} -ZLTf";
Message "xyz2grd DEM2ok -GDEM2ok.grd -I$incx -R${xinterm}/${xMaxi}/${ymini}/${yMaxi} -ZLTf";

`$GMT_BIN/xyz2grd DEM1ok -GDEM1ok.grd -I$incx -R${xmini}/${xinterm}/${ymini}/${yMaxi} -ZLTf`;
`$GMT_BIN/xyz2grd DEM2ok -GDEM2ok.grd -I$incx -R${xinterm}/${xMaxi}/${ymini}/${yMaxi} -ZLTf`;

Message "grdmerge.pl -GDEMok.grd DEM*ok.grd";

`$MAKEDEM_SCR/grdmerge.pl -GDEMok.grd DEM*ok.grd`;

Message "#################";
Message ">>>>Build ps file";
Message "#################";

`$GMT_BIN/gmtset PAGE_ORIENTATION portrait`;
$file="DEMok.grd";
chomp $file;
`$GMT_BIN/grd2cpt -Crainbow $file > ${file}.cpt -V`;
`$GMT_BIN/grdgradient $file -A0/270 -G${file}_grad -Ne0.6 -V`;
`$GMT_BIN/grdimage $file -JM16c -I${file}_grad -V -R${xmin}/${xmax}/${ymin}/${ymax} -C$file.cpt > ${file}.ps`; 

Message "###############################";
Message ">>>>Suitable format for roi_pac";
Message "###############################";

`$GMT_BIN/grdinfo DEMok.grd > Tmp.gmt`;
 $xmin =`grep 'nx' Tmp.gmt | awk '{print \$3 }'`;
 chomp $xmin;
 $xmax =`grep 'nx' Tmp.gmt | awk '{print \$5 }'`;
 chomp $xmax;
 $ymin =`grep 'ny' Tmp.gmt | awk '{print \$3 }'`;
 chomp $ymin;
 $ymax =`grep 'ny' Tmp.gmt | awk '{print \$5 }'`;
 chomp $ymax;

$call_str="$MAKEDEM_SCR/grd2rsc.csh DEMok.grd";
Message "$call_str \n" ; `$call_str`;

Message "#########################";
Message ">>>> Resampling if needed";
Message "#########################";

print STDERR "$MAKEDEM_SCR/lookdem.pl DEMok.dem -o DEMok --resample $FactincX/$FactincX \n";

$fact ne 1 and `$MAKEDEM_SCR/lookdem.pl DEMok.dem -o DEMok --resample  $FactincX/$FactincX`;

Message "############";
Message ">>>> Rename ";
Message "############";

if ($ofile eq ''){
`mv  DEMok.dem roi${xmin}_${ymin}.dem`;
`mv  DEMok.dem.rsc roi${xmin}_${ymin}.dem.rsc`;
`mv DEMok.grd roi${xmin}_${ymin}.dem.grd`;

$call_str="$MAKEDEM_SCR/prepare_dem.pl roi${xmin}_${ymin}.dem";
Message "$call_str \n" ; `$call_str`;
}

else{
`mv  DEMok.dem $ofile.dem`;
`mv  DEMok.dem.rsc $ofile.dem.rsc`;
`mv  DEMok.grd $ofile.dem.grd`;

$call_str="$MAKEDEM_SCR/prepare_dem.pl $ofile.dem";
print STDERR "$call_str \n" ; `$call_str`;
}

Message "###########################";
Message ">>>>Clean files and display";
Message "###########################";

chdir $rpwd;
`mv tmp/*{dem,ps}* .`;
`rm -r -f $rpwd/tmp`;

unless ($nodisplay){
  `display  ${ofile}.dem.jpeg`;
  `display  ${file}.ps`;
}



