#!/usr/bin/perl 
### prepare_dem.pl

$] >= 5.004 or die "Perl version must be >= 5.004 (Currently $]).\n";

use Env qw(MAKEDEM_SCR MAKEDEM_BIN INT_SCR);
use lib "$INT_SCR";  #### Location of Generic.pm
use Generic;

###Usage info/check
sub Usage{
print STDERR "prepare_dem.pl DEMfile \n";
print STDERR "\n       generates slope, shade and jpeg files \n";
print STDERR "         runs gradient.pl, shade and hgt2rgb_jpeg     \n";
exit 1;
}
@ARGV >= 1 or Usage();
@args = @ARGV;
Log("prepare_dem.pl", @args);

$pi   = atan2(1,1)*4;

$demfile    = shift;
        ($base,$junk)=split /.dem/,$demfile ; 
$slopefile  = "$base.slp";
$shadefile  = "$demfile.byt";

#################
Message "Checking I/O";
#################
@Infiles  = ("$demfile",     "$demfile.rsc");
@Outfiles = ("$slopepfile",  "$slopefile.rsc"    ,
             "$shadefile",   "$shadefile.rsc"    );

#&IOcheck(\@Infiles, \@Outfiles);

$call_str="$INT_SCR/gradient.pl $demfile $slopefile" ;
####################################
Message "Creating slope file: $call_str";
####################################
`$call_str`;
Status "gradient.pl";

#################
Message "Reading resource file: $demfile.rsc";
#################
$width  = Use_rsc "$demfile read WIDTH";
$length = Use_rsc "$demfile read FILE_LENGTH";
$x_first = Use_rsc "$demfile read X_FIRST";
$y_first = Use_rsc "$demfile read Y_FIRST";
$x_step = Use_rsc "$demfile read X_STEP";
$y_step = Use_rsc "$demfile read Y_STEP";
use POSIX;
$x_east = $x_first+$x_step*($width-1);
$y_south = $y_first+$y_step*($length-1);
$gy_step = -$y_step;
$projection = Use_rsc "$demfile read PROJECTION";

$projection =~ "UTM" and $pixdim = $x_step ;
$projection =~ "LATLON" and $pixdim  = int (cos ($y_first/180*$pi) * 111 * 1000 * abs($x_step) + 0.5 ) ; ## asumes latlong

print STDERR "<$projection><$pixdim> \n"; #exit ;

#################
Message "Creating shaded relief files";
#################
`cp $demfile.rsc $shadefile.rsc`;
$call_str="$MAKEDEM_BIN/shade $demfile $shadefile $width $length 1 45 100 $pixdim 0" ;
Message "$call_str" ; `$call_str`;

$call_str="$MAKEDEM_BIN/write_zerohgt dumhgtfile.hgt $width $length";
Message "$call_str" ; `$call_str`;

$call_str="$MAKEDEM_BIN/hgt2rgb_jpeg dumhgtfile.hgt $shadefile $demfile.jpeg $width 6";
Message "$call_str" ; `$call_str`;

$call_str="$MAKEDEM_BIN/hgt2rgb_jpeg dumhgtfile.hgt $shadefile $demfile.jpeg $width 6";
Message "$call_str" ; `$call_str`;
`cp $demfile.rsc $demfile.jpeg.rsc`;
#################
# FA Sep 2007: temporary until geodmod supports reading of i2 dem files
$call_str="$MAKEDEM_BIN/i22hgt $demfile $demfile.hgt $width" ; 
Message "$call_str" ; `$call_str`;
`cp $demfile.rsc $demfile.hgt.rsc`;

#system "display  $demfile.jpeg &" ;

exit 0;
