#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <fstream.h>

extern void aspect (unsigned char *idat, float *outdat, int ns, 
	int dtype, float pixdim)  ;

int main (int argc, char *argv[]) 
{

	unsigned char *indat=NULL, *iptr ;
	char 	infile [240], outfile [240] ;
	int	i, ns, nl, dtype, bpp [4] = {1,2,4,4}, bytesperpx ;
	float 	sunelev, sunaz, pixdim, maskval=-1.E5 ;
	float   *optr, *outdat ;

	// get the arguments from the command line
	if (argc <5)
	{
		cout << "Usage : aspect infile outfile ns dtype pixdim  " <<
			endl ;
		return (0) ;
	}

	strcpy (infile, *++argv) ;
	strcpy (outfile, *++argv) ;
	ns = atoi (*++argv) ;
	dtype = atoi (*++argv) ;
	bytesperpx = bpp [dtype] ;

	ifstream ifil (infile, ios::in) ;
	ifil.seekg (0, ios::end) ;
	long filepos = ifil.tellg () ;
	nl = filepos / (ns * bytesperpx) ;





	pixdim = atof (*++argv) ;
	


	// allocate memory 
	outdat = new float [ns * nl] ;
	for (i=0; i<ns * nl; i++) *(outdat+i) = 0. ;

	indat = new unsigned char [ns * nl * bytesperpx] ;
	if (indat ==NULL || outdat==NULL) {
		cout << "Could not alloc memory \n" << endl ;
		return (-1) ;
	}

	

       	ofstream ofil (outfile, ios::out) ;
	if (ifil.bad()) {
		cout << "Problem with input file " << infile << endl ;
		return (-1) ;
	}
	if (ofil.bad()) {
		cout << "Problem with output file " << outfile << endl ;
		return (-1) ;
	}
	ifil.seekg (0, ios::beg) ;
	ifil.read (indat, ns * nl * bytesperpx) ;
	ifil.close() ;

	for (i=1; i<nl-1; i++)
	  {
	    iptr = indat + i * ns * bytesperpx ;
	    optr = outdat + i * ns ;
	    aspect (iptr, optr, ns, dtype, pixdim) ;
	  }
	// write out output data
	ofil.write (outdat, ns * nl * 4) ;
	ofil.close () ;
	

	// dealloc memory
	delete [] indat ;
	delete [] outdat ;

}
	

