#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <setjmp.h>
#include <math.h>
extern "C" {
#include "jpeglib.h"
}


int main (int argc, char *argv[]) 
{

	char 	demfile [240], intensfile [240], outfile [240] ;
	char 	lutfile [240] ;
	unsigned char *outline, *intens ;

	float   *heights, *mag ;
	short   *sptr ;
	int	contint, *iptr ;
	int	i, j, ival, ns, nl, dtype, bpp, bytesppx [4]={1,2,4,4} ;
	int	bytesperline, applylut = 0 ;
	float   red [360], grn [360], blue[360] ;
	int	lut_r [256], lut_g [256], lut_b [256] ;
	float   hval, *fptr, *newheight ;
	double  offset=0. ;
	long    fpos ;

	if (argc < 6) {
		cout <<"usage : hgt2rgb_jpeg hgtfile intensfile outjpegfile ns contint <offset=0> <rgb.lut> " << endl ;

		return (0) ;
	}

	
	strcpy (demfile, *++argv) ;
	strcpy (intensfile, *++argv) ;
	strcpy (outfile, *++argv) ; 
	ns = atoi (*++argv) ;
	contint = atoi (*++argv) ;
	//dtype = atoi (*++argv) ;
	if (argc > 6) {
		offset = atof (*++argv) ;
	}
	if (argc > 7) {
		strcpy (lutfile, *++argv) ;
		applylut = 1 ;
	}
	dtype = 3 ;
	bytesperline = bytesppx [dtype] * ns;
	bpp = bytesppx [dtype] ;

	ifstream intfile (intensfile, ios::in) ;

	// jpeg stuff
	struct 		jpeg_error_mgr jerr ;
	JSAMPROW	row_pointer [1] ;
	int		row_stride ;
	FILE *ofile ; 
	ofile = fopen (outfile, "wb") ;
	if (ofile==NULL) {
		cout << "problem opening output file " << outfile << endl ;
		exit (-1) ;
	}

	struct 		jpeg_compress_struct cinfo ;
	cinfo.err = jpeg_std_error (&jerr) ;
	jpeg_create_compress (&cinfo) ;
	jpeg_stdio_dest (&cinfo, ofile) ;
	
	

	// assign values to the phase:
        for (i=0; i<120; i++)
        {
                red [i] = float(i) * 2. * 155./255. + 100 ;
                grn [i] = float (119. -i) * 2. * 155./255. + 100. ;
                blue [i] = 255. ;
        }
        for (i=120; i<240; i++)
        {
                ival = i - 120 ;
                red [i] = 255. ;
                grn [i] = float (ival) *  2. * 155./255. + 100. ;
                blue [i] = float (239. - i) * 2. * 155./ 255. + 100. ;
        }
        for (i=240; i<360; i++)
        {
                ival = i - 240 ;
                red [i] = float (359. - i)  * 2. * 155. / 255. + 100. ;
                grn [i] = 255. ;
                blue [i] = float (ival) * 2. * 155. / 255. + 100. ;
        }

	ifstream dfile (demfile, ios::in) ;  
	dfile.seekg (0, ios::end) ;
	fpos = dfile.tellg() ;
	nl = fpos / (bytesperline * 2) ;
	dfile.seekg (0, ios::beg) ;

	// jpeg file dimensions and color space
	cinfo.image_width = ns ;
	cinfo.image_height = nl ;
	cinfo.input_components  = 3 ;
	cinfo.in_color_space = JCS_RGB ;


	jpeg_set_defaults (&cinfo) ;
	jpeg_set_quality( &cinfo, 90, TRUE) ;
	jpeg_start_compress (&cinfo, TRUE) ;
	row_stride= ns * 3 ;

	heights = new float [ns] ;
	mag = new float [ns] ;
	newheight = new float [ns] ;
	intens = new unsigned char [ns] ;
	outline = new unsigned char [ns * 3] ;

	// look up table if applylut is true
	if (applylut)
	{
		char line [580] ;
		ifstream ilut (lutfile, ios::in) ;
		ilut.getline (line, 180, '\n') ;
		ilut.getline (line, 180, '\n') ;
		for (i=0; i<255; i++) ilut >> lut_r[i] >>
			lut_g [i] >> lut_b [i] ;
		lut_r[255] = lut_r[254] ;
		lut_g[255] = lut_g[254] ;
		lut_b[255] = lut_b[254] ;
	}
	// get the height data and scale to something or other
	for (i=0; i<nl; i++) {
		// read in the height data
		dfile.read ((char *)mag, bytesperline) ;
		dfile.read ((char *)heights, bytesperline) ;
		intfile.read ((char *)intens, ns) ;
		// read in the intensity data 
			for (j=0; j<ns; j++) 
			{
				float checkval = *(mag + j ) * *(mag + j) ;
				if (checkval >(-.000001) && checkval < (.00001)) *(newheight+j) = -9999. ;
				else 
			  		*(newheight + j) = (float) ((*(heights + j))+offset) ;
			}
				
		int itmpval, tmpval ;
		float remainder ;
		for (j=0; j<ns; j++) 
		{
			if (*(newheight+j) < (-9998.99999) && *(newheight+j) > (-9999.00001)) {
				*(outline+j*3) = (unsigned char) *(intens+j) ;
				*(outline+j*3+1) = (unsigned char)  *(intens+j) ; 
				*(outline+j*3+2) =  (unsigned char) *(intens+j) ; 
				continue ;
			}	
			itmpval = int ((*(newheight+j)) / contint) ;
			remainder = *(newheight+j) - itmpval *contint ;
			if (remainder<0) {//remainder *= -1. ;
				remainder += contint ; 
				}
			tmpval = int (remainder / contint * 360.) ;
			if (!applylut)
			{
			*(outline + j * 3+0) = (unsigned char) (red[tmpval] * float(*(intens+j))/255.) ;
			*(outline + j * 3+1) = (unsigned char) (grn[tmpval] * float(*(intens+j))/255.) ;
			*(outline + j * 3+2) = (unsigned char) (blue [tmpval] * float(*(intens+j))/255.) ;
			}
			else {
			*(outline + j * 3) = lut_r [(int) (red[tmpval] * float(*(intens+j))/255.) ] ;
			*(outline + j * 3 + 1) = lut_g [(int) (grn[tmpval] * float(*(intens+j))/255.) ] ;
			*(outline + j * 3+2) = lut_b [(int) (blue[tmpval] * float(*(intens+j))/255.) ] ;
			}

		}
		//ofile.write (outline, ns * 3) ;
		row_pointer [0] = &outline [0] ;
		jpeg_write_scanlines (&cinfo, row_pointer, 1) ;

	}

	jpeg_finish_compress (&cinfo) ;
	fclose (ofile) ;
	jpeg_destroy_compress (&cinfo) ;

	delete [] outline ;
	delete [] newheight ;
	delete [] intens ;
	delete [] heights ;

	dfile.close () ;
	intfile.close () ;
	return 0;
}







