#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <fstream.h>

extern void shade (unsigned char *idat, unsigned char *outdat, int ns, int nl, 
	int dtype, float sunelev, float sunaz, float pixdim, float maskval)  ;

int main (int argc, char *argv[]) 
{

	unsigned char *indat=NULL, *outdat=NULL, *iptr ;
	char 	infile [240], outfile [240] ;
	int	ns, nl, dtype, bpp [4] = {1,2,4,4}, bytesperpx ;
	int     i, j ;
	float 	sunelev, sunaz, pixdim, maskval=-1.E5, *tmpflt, *outflt ;

	// get the arguments from the command line
	if (argc <8)
	{
		cout << "Usage : shade htfile outfile ns nl sunelev sunaz pixdim <maskval> " <<
			endl ;
		return (0) ;
	}

	dtype = 3 ;
	strcpy (infile, *++argv) ;
	strcpy (outfile, *++argv) ;
	ns = atoi (*++argv) ;
	nl = atoi (*++argv) ;

	sunelev = atof (*++argv) ;
	sunaz = atof (*++argv) ;
	pixdim = atof (*++argv) ;
	
	if (argc >9)
	maskval = atof (*++argv) ;

	// allocate memory 
	outdat = new unsigned char [ns * nl] ;
	bytesperpx = bpp [dtype] ;
	tmpflt = new float [ns] ;
	indat = new unsigned char [ns * nl * bytesperpx] ;
	if (indat ==NULL || outdat==NULL) {
		cout << "Could not alloc memory \n" << endl ;
		return (-1) ;
	}

	// get the height data and open output file
	ifstream ifil (infile, ios::in) ;
	ofstream ofil (outfile, ios::out) ;
	if (ifil.bad()) {
		cout << "Problem with input file " << infile << endl ;
		return (-1) ;
	}
	if (ofil.bad()) {
		cout << "Problem with output file " << outfile << endl ;
		return (-1) ;
	}
	ifil.seekg (0, ios::beg) ;
	for (i=0; i<nl; i++) {
		ifil.seekg (ns * bytesperpx, ios::cur) ;
		ifil.read ((char *)(indat + i * ns * bytesperpx), ns * bytesperpx) ;
	}
	ifil.close() ;

	
	shade (indat, outdat, ns, nl, dtype, sunelev, sunaz, pixdim, maskval) ;
	// write out output data
	for (i=0; i<nl; i++) {
		for (j=0; j<ns; j++) {
			outflt = tmpflt + j ; 
			iptr = outdat + i * ns + j ;
			*outflt = (float) (*iptr) / 255. ;
		}
		ofil.write ((char *)tmpflt, ns * 4) ;
		ofil.write ((char *)(indat + i * ns * 4), ns * 4) ;
	}
	ofil.close () ;
	

	// dealloc memory
	delete [] indat ;
	delete [] outdat ;
	delete [] tmpflt ;
	return 0;
}
	

