#include <iostream.h>
#include <fstream.h>
#include <math.h>
#include "constants.h"

template <class kind>
void tshade (kind *indat, unsigned char *outdat, int ns, int nl, 
	float sunelev, float sunaz,
	float pixdim, float maskval) ;

void shade (unsigned char *indat, unsigned char *outdat, int ns, int nl,
	int dtype, float sunelev, float sunaz, float pixdim, float maskval) 
{
	if (dtype==0)
 	tshade (indat, outdat, ns, nl, sunelev,  sunaz, pixdim, maskval) ;
	if (dtype==1)
 	tshade ((short *)indat, outdat, ns, nl, sunelev,  sunaz, pixdim, maskval) ;
	if (dtype==2)
 	tshade ((int *)indat, outdat, ns, nl, sunelev,  sunaz, pixdim, maskval) ;
	if (dtype==3)
 	tshade ((float *)indat, outdat, ns, nl, sunelev,  sunaz, pixdim, maskval) ;

}


template <class kind>
void tshade (kind *indat, unsigned char *outdat, int ns, int nl, 
	float sunelev, float sunaz,
	float pixdim, float maskval)
{
	unsigned char 	*outptr ;
	kind		*iptr ;
	int 		i, j, js, npts_top, npts_bot, npts_lft, npts_rht ;
	float		fval, lftsum, rhtsum, topsum, botsum ;
	double 		dx, dy, a[3], b[3], alpha ;

	// calculate the unit vector depicting the sun direction
	cout << "Azimuth is   " << sunaz << endl ;
	cout << "Elevation is " << sunelev << endl ;
	sunaz *= DEG2RAD ;
	sunelev *= DEG2RAD ;
	b [0] = sin (sunaz) * cos (sunelev) ;
	b [1] = cos (sunaz) * cos (sunelev) ;
	b [2] = sin (sunelev) ;

	// initialize the first line to zero
	for (j=0; j<ns; j++)
		*(outdat + j) = 0 ;

	for (i=1; i<nl-1; i++)
	{
		outptr = outdat + i * ns ;
		for (j=0; j<ns; j++)
			*(outptr+j) = 0 ;
		for (j=1; j<ns-1; j++)
		{
			// get the top three pixels	
			npts_top = 0 ;
			topsum = 0. ;
			iptr = indat + (i-1) * ns + j - 1 ;
			for (js=0; js<3; js++)
			{
				fval = (float) *(iptr+js) ;
				if (fval > maskval) 
				{
					topsum += fval ;
					npts_top++ ;
				}
			}
			if (npts_top) topsum /= npts_top ;
			else 
			{
				*(outptr +j) = 0 ;
				continue ;
			}
			// get the bot three pixels	
			npts_bot = 0 ;
			botsum = 0. ;
			iptr = indat + (i+1) * ns + j - 1 ;
			for (js=0; js<3; js++)
			{
				fval = (float) *(iptr+js) ;
				if (fval > maskval) 
				{
					botsum += fval ;
					npts_bot++ ;
				}
			}
			if (npts_bot) botsum /= npts_bot ;
			else 
			{
				*(outptr +j) = 0 ;
				continue ;
			}
			// get the left three pixels	
			npts_lft = 0 ;
			lftsum = 0. ;
			iptr = indat + (i-1) * ns + j - 1 ;
			for (js=0; js<3; js++)
			{
				fval = (float) *(iptr+js*ns) ;
				if (fval > maskval) 
				{
					lftsum += fval ;
					npts_lft++ ;
				}
			}
			if (npts_lft) lftsum /= npts_lft ;
			else 
			{
				*(outptr +j) = 0 ;
				continue ;
			}
			// get the right three pixels	
			npts_rht = 0 ;
			rhtsum = 0. ;
			iptr = indat + (i-1) * ns + j + 1 ;
			for (js=0; js<3; js++)
			{
				fval = (float) *(iptr+js*ns) ;
				if (fval > maskval) 
				{
					rhtsum += fval ;
					npts_rht++ ;
				}
			}
			if (npts_rht) rhtsum /= npts_rht ;
			else 
			{
				*(outptr +j) = 0 ;
				continue ;
			}

			// if we get to this point all direct derivs
			// can be calculated
			dx = (lftsum - rhtsum) / (2. * pixdim) ;
			dy = (botsum - topsum) / (2. * pixdim) ;

			a [0] = dx / sqrt(dx * dx + dy * dy + 1.) ;
			a [1] = dy / sqrt(dx * dx + dy * dy + 1.) ;
			a [2] = 1. / sqrt(dx * dx + dy * dy + 1.) ;

			alpha = a[0] * b[0] + a[1] * b[1] + a[2] * b[2] ;
			alpha *=255. ;
			alpha =(alpha<0.) ? 0. : alpha ;
			alpha =(alpha>255.) ? 255. : alpha ;
			*(outptr + j) = (unsigned char) alpha ;
		}
	}
}
						
		
		 
	
