#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <fstream.h>

extern void shade (unsigned char *idat, unsigned char *outdat, int ns, int nl, 
	int dtype, float sunelev, float sunaz, float pixdim, float maskval)  ;

int main (int argc, char *argv[]) 
{

	unsigned char *indat=NULL, *outdat=NULL ;
	char 	infile [240], outfile [240] ;
	int	ns, nl, dtype, bpp [4] = {1,2,4,4}, bytesperpx ;
	float 	sunelev, sunaz, pixdim, maskval=-1.E5 ;

	// get the arguments from the command line
	if (argc <9)
	{
		cout << "Usage : shade infile outfile ns nl dtype sunelev sunaz pixdim <maskval> " <<
			endl ;
		return (0) ;
	}

	strcpy (infile, *++argv) ;
	strcpy (outfile, *++argv) ;
	ns = atoi (*++argv) ;
	nl = atoi (*++argv) ;
	dtype = atoi (*++argv) ;

	sunelev = atof (*++argv) ;
	sunaz = atof (*++argv) ;
	pixdim = atof (*++argv) ;
	
	if (argc >9)
	maskval = atof (*++argv) ;

	// allocate memory 
	outdat = new unsigned char [ns * nl] ;
	bytesperpx = bpp [dtype] ;
	indat = new unsigned char [ns * nl * bytesperpx] ;
	if (indat ==NULL || outdat==NULL) {
		cout << "Could not alloc memory \n" << endl ;
		return (-1) ;
	}

	// get the height data and open output file
	ifstream ifil (infile, ios::in) ;
	ofstream ofil (outfile, ios::out) ;
	if (ifil.bad()) {
		cout << "Problem with input file " << infile << endl ;
		return (-1) ;
	}
	if (ofil.bad()) {
		cout << "Problem with output file " << outfile << endl ;
		return (-1) ;
	}
	ifil.read ((char *)indat, ns * nl * bytesperpx) ;
	ifil.close() ;

	
	shade (indat, outdat, ns, nl, dtype, sunelev, sunaz, pixdim, maskval) ;
	// write out output data
	ofil.write ((char *)outdat, ns * nl) ;
	ofil.close () ;
	

	// dealloc memory
	delete [] indat ;
	delete [] outdat ;
	return 0;
}
	

